// api/schema.js
const { gql } = require('apollo-server');

const typeDefs = gql`
  type User {
    id: ID!
    name: String!
    email: String!
  }

  type Query {
    users: [User]
  }

  type Mutation {
    createUser(input: UserInput!): User
  }

  input UserInput {
    name: String!
    email: String!
  }
`;

module.exports = typeDefs;
